library fmt_ATLBased;

  //////////////////////////////////////////////////////
  //      MuzCat v1.43   //
  // (C) 2004 PA (ZLDO)                               //
  //////////////////////////////////////////////////////

uses
  Windows, KOL,  {  KOL - http://bonanzas.rinet.ru }
  FormatHeader in 'FormatHeader.pas',
  WorkUnit in 'WorkUnit.pas';



function ApiVersion: integer; stdcall;
begin
  result := 1;
end;

procedure SetInfoFromGlobalBuf(Const Info:PBasicInfoRec);
//    Info  
begin
  with Info^ do
  begin
    if Size<SizeOf(TBasicInfoRec) then exit;
    Title := PChar(GlobalInfBuf.Title);
    Artist := PChar(GlobalInfBuf.Artist);
    Album := PChar(GlobalInfBuf.Album);
    Comment := PChar(GlobalInfBuf.Comment);
    Genre := PChar(GlobalInfBuf.Genre);
    Date := PChar(GlobalInfBuf.Date);
    Time := GlobalInfBuf.Time;
    BitRate := GlobalInfBuf.BitRate;
    TrackNo := GlobalInfBuf.TrackNo;
    TagPr := GlobalInfBuf.TagPr;
  end;
end;

procedure ResetGlobalBuf;
//    Info  
begin
  with GlobalInfBuf do
  begin
    Title   := '';
    Artist  := '';
    Album   := '';
    Comment := '';
    Genre   := '';
    Date    := '';
    Time    := 0;
    BitRate := 0;
    TrackNo := 255;
    TagPr   := false;
  end;
end;

function NotifyProc(Const fmReason:integer;Const data:integer): integer; stdcall;
begin
  result := 0;
  case fmReason of
    fm_Resume:AppHandle:=data; //     

    fm_Suspend: ; //  
  end;
end;

function TagRead(Const Info: PBasicInfoRec):boolean;stdcall;
//  
begin
{   Add('aac');  // 0
    Add('ape');  // 1
    Add('mpc');  // 2
    Add('flac'); // 3
    Add('mp3');  // 4
    Add('mp2');  // 5
    Add('mp+');  // 6
    Add('vqf');  // 7
    Add('wma');  // 8
    Add('asf');  // 9
}
  try
    ResetGlobalBuf;
    case ExtToIdx(ExtractFileExt(Info.FilePath)) of

      0:      Result := Read_aacTag(Info);
      1..2:   Result := Read_apeTag(Info);
      3:      Result := Read_FLACTag(Info);
      4..5:   Result := Read_MpegTag(Info);
      6:      Result := Read_MpegPlusTag(info);
      7:      Result := Read_TwinVQTag(Info);
      8..9:   Result := Read_wmaTag(Info);
      10:     Result := Read_CDATag(Info);

      else result := false;
    end;
    if (not GlobalInfBuf.TagPr) or ((Trim(GlobalInfBuf.Title) = '') and (Trim(GlobalInfBuf.Artist) = ''))
     then GlobalInfBuf.Title := ExtractFileName(ChangeFileExt(Info.FilePath,''));
    SetInfoFromGlobalBuf(Info);
  except
    result:=false;
  end;
end;

function TagWrite(Const Info: PBasicInfoRec):boolean;stdcall;
//  
begin
  try
    case ExtToIdx(ExtractFileExt(Info.FilePath)) of

      0:      Result := Write_aacTag(Info);
      1..2:   Result := Write_apeTag(Info);
      3:      Result := Write_FLACTag(Info);
      4..5:   Result := Write_MpegTag(Info);
      6:      Result := Write_MpegPlusTag(info);
      7:      Result := Write_TwinVQTag(Info);
      8..9:   Result := Write_wmaTag(Info);

      else result := false;
    end;
  except
    result:=false;
  end;
end;

procedure ABOUT(Var AboutString:PChar);stdcall;
Begin
  AboutString := PChar(Description);
End;

procedure  GETEXT(Var Ext:PChar);stdcall;
Begin
 Ext:=PChar(dllExt);
End;

procedure CONFIGURE(Const Window:THandle);stdcall;
Begin
  MessageBox(Window,PChar(Description),'ATLBased',0);
End;


procedure GETFILEINFO(Const FileName:PChar;Var info:PChar);stdcall;
Begin
   try
    FileInfoBuf := ''; 
    case ExtToIdx(ExtractFileExt(FileName)) of

      0:      Info_aac(FileName,info);
      1..2:   Info_ape(FileName,info);
      3:      Info_FLAC(FileName,info);
      4..5:   Info_MpegAudio(FileName,info);
      6:      Info_MpegPlus(FileName,info);
      7:      Info_TwinVQ(FileName,info);
      8..9:   Info_WMA(FileName,info);

    end;
    info := PChar(FileInfoBuf);
  except
    info := nil;
  end;
End;

exports
   ApiVersion,
   NotifyProc,
   TagRead,
   TagWrite,
   GETEXT,
   ABOUT,
   CONFIGURE,
   GETFILEINFO;


begin
end.
